/********************************************************************
 *
 *	TITLE:	   xgen16
 *
 *	DATE:	   05-26-82
 *
 *	ABSTRACT:  .
 *
 *	LANGUAGE DEPENDENCIES:
 *
 *		C86     VERSION 1.0
 *
 *********************************************************************/
#include <curses.h>
#include <signal.h>
#include "common.def"

	/*
	 *  Public variables
	 */

char path[NAMEMAX];
unsigned  buf_size;
int  end_io;
int  end_8087;
int  t_line;

	/*
	 *  External variables
	 */
	 
extern int  synch[2];
extern int all_io;
extern int all_math;
extern int num_8087;
extern char *index();

extern struct {
	int       number;
	unsigned  min;
	unsigned  max;
	char name[NAMEMAX];
} paths[P_MAX];


/********************************************************************
 *
 *	TITLE:	   create
 *
 *	CALLING SEQUENCE:
 *
 *		   create( t8087 );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
create( t8087 )
bool t8087;
{
int actual;
int fkret;
char msg[16];


	/*
	 *  Create process
	 */

	fkret = fork();
	if ( fkret == -1 )
		err_msg( "Bad fork of test process", "", TRUE );

	if ( fkret == 0 ) {
		signal( SIGINT, SIG_DFL );

		/*
		 * drop priority
		 */

		nice( 2 );

		if ( t8087 ) {

			/*
			 *  Drop priority lower
			 */

			nice( 1 );
			x8087();
		}
		else
			io_test();
	}

	actual = read( synch[0], msg, sizeof(msg) );
	if ( actual == E_IO )
		err_msg( "Bad parent read of synch pipe", "", TRUE );
}

/********************************************************************
 *
 *	TITLE:	   query_size
 *
 *	CALLING SEQUENCE:
 *
 *		   query_size( min, max );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
query_size( min, max )
unsigned min, max;
{


	buf_size = query_int( t_line, 20, "> " );

	if ( buf_size == 0 )
		buf_size = roll( min, max );
	move( t_line, 21 );
	clrtoeol();
	refresh();
	mvprintw( t_line, 22, "%-5u", buf_size );
}

/********************************************************************
 *
 *	TITLE:	   expand
 *
 *	CALLING SEQUENCE:
 *
 *		   expand( num );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
expand( num )
int num;
{
char *sp;
char *nextsp;
char temp[NAMEMAX];
char number[3];
char save;


	if ( (sp = index( path, '#' )) == 0 )
		return;

	/*
	 *  Copy remainder of path name into temporary string
	 */

	strcpy( temp, sp + 1 );	

	/*
	 *  Convert number and concatenate to path name
	 */

	sprintf( number, "%1d", num );

	*sp = '\0';
	strcat( path, number );
	
	/*
	 *  Concatenate remainder of name to path name
	 */

	strcat( path, temp );

}

/********************************************************************
 *
 *	TITLE:	   gen_io
 *
 *	CALLING SEQUENCE:
 *
 *		   gen_io();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
gen_io()
{
int i, j;


	t_line = end_io;
	for ( i = 0; strcmp( paths[i].name, "" ) && i < P_MAX && t_line < LAST_LINE; ++i ) {

		for ( j = 1; j <= paths[i].number && t_line < LAST_LINE; ++j ) {

			t_line = t_line + 1;
			strcpy( path, paths[i].name );
			expand( j );

			mvaddstr( t_line, 01, path );

			if ( paths[i].min == 0xffff ) 
				query_size( DEF_MIN, DEF_MAX );

			else {
				if ( paths[i].min == paths[i].max )
					buf_size = paths[i].min;

				else
					buf_size = roll( paths[i].min, paths[i].max );

				mvprintw( t_line, 22, "%5u",  buf_size );
			 }

			create( FALSE );
		}
	}

	end_io = t_line;
}

/********************************************************************
 *
 *	TITLE:	   question
 *
 *	CALLING SEQUENCE:
 *
 *		   question( end_line );
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
question( end_line )
int end_line;
{


	t_line = end_io;

	while ( t_line < end_line ) {

		t_line = t_line + 1;
		/*
		 *  query for file name
		 */

		query( t_line, 00, ">", path );
		if ( strlen( path ) > NAMEMAX )
			err_msg( path, ", file name to long", FALSE );

		/*
		 *  Check if no more tests
		 */

		if ( strlen( path ) == 0 ) {
			if ( t_line == 2 )
				clear();
			else {
				move( t_line, 00 );
				clrtobot();
			}
			refresh();
			end_io = t_line - 1;
			return;
		}

		else {
			query_size( DEF_MIN, DEF_MAX );
			create( FALSE );
		}
	}

	end_io = t_line;
}

/********************************************************************
 *
 *	TITLE:	   c_8087
 *
 *	CALLING SEQUENCE:
 *
 *		   c_8087();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
c_8087()
{
int end_line;
int i;


	t_line = ( end_io == 1 ) ? 1 : end_io + 2;

	/*
	 *  Determine number of 8087 tests
	 */

	if ( num_8087 == 0 ) {
		mvprintw( t_line, 01, "How many 8087 tests: %2d possible?", (LAST_LINE - t_line ));
		num_8087 = query_int( t_line, 36 );
		move( t_line, 00 );
		clrtoeol();
		refresh();

		if ( num_8087 == 0 ) {
			end_8087 = 1;
			question( LAST_LINE );
			return;
		}
	}

	if ( num_8087 > LAST_LINE - t_line )
		num_8087 = LAST_LINE - t_line;
	/*
	 *  Create tasks
	 */

	for ( i = 1; i <= num_8087; i++ ) {

		++t_line;

		create( TRUE );

	}

	end_8087 = t_line;

}

/********************************************************************
 *
 *	TITLE:	   gen16
 *
 *	CALLING SEQUENCE:
 *
 *		   gen16();
 *
 *	INTERFACE VARIABLES:
 *
 *		   .
 *              
 *	CALLS:	   .
 *
 *	ABSTRACT:  .
 *
 *
 *********************************************************************/
gen16()
{

	/*
	 *  Create the tests 
	 */

	end_io = 1;
	if ( all_io ) {
		fheader();
		end_8087 = 1;
		gen_io();
		if ( end_io < LAST_LINE )
			question( LAST_LINE );

	}
	else {
		if ( all_math )
			c_8087();
		else {
			fheader();

			gen_io();
			if ( end_io < LAST_LINE - 2 ) {
				if ( num_8087 == 0 )
					question( LAST_LINE - 3 );

				c_8087();
			}
			else {
				end_8087 = 0;
				if ( end_io < LAST_LINE )
					question( LAST_LINE );
			}
		}
	}

 }

